
void _efl_canvas_gesture_touch_point_record(Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd, Efl_Input_Pointer *event);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gesture_touch_point_record, EFL_FUNC_CALL(event), Efl_Input_Pointer *event);

Eina_Vector2 _efl_canvas_gesture_touch_delta(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd, int tool);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV_CONST(efl_gesture_touch_delta, Eina_Vector2, ((Eina_Vector2){0}), EFL_FUNC_CALL(tool), int tool);

Eina_Vector2 _efl_canvas_gesture_touch_distance(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd, int tool);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV_CONST(efl_gesture_touch_distance, Eina_Vector2, ((Eina_Vector2){0}), EFL_FUNC_CALL(tool), int tool);

Eina_Position2D _efl_canvas_gesture_touch_start_point_get(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_touch_start_point_get, Eina_Position2D, ((Eina_Position2D){0}));

Eina_Position2D _efl_canvas_gesture_touch_current_point_get(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_touch_current_point_get, Eina_Position2D, ((Eina_Position2D){0}));

unsigned int _efl_canvas_gesture_touch_current_timestamp_get(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd);


static Eina_Value
__eolian_efl_canvas_gesture_touch_current_timestamp_get_reflect(const Eo *obj)
{
   unsigned int val = efl_gesture_touch_current_timestamp_get(obj);
   return eina_value_uint_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_touch_current_timestamp_get, unsigned int, 0);

unsigned int _efl_canvas_gesture_touch_touch_points_count_get(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd);


static Eina_Value
__eolian_efl_canvas_gesture_touch_touch_points_count_get_reflect(const Eo *obj)
{
   unsigned int val = efl_gesture_touch_points_count_get(obj);
   return eina_value_uint_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_touch_points_count_get, unsigned int, 0);

Efl_Canvas_Gesture_Touch_State _efl_canvas_gesture_touch_state_get(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_touch_state_get, Efl_Canvas_Gesture_Touch_State, 0);

const Efl_Gesture_Touch_Point_Data *_efl_canvas_gesture_touch_current_data_get(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_touch_current_data_get, const Efl_Gesture_Touch_Point_Data *, NULL);

const Efl_Gesture_Touch_Point_Data *_efl_canvas_gesture_touch_previous_data_get(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_touch_previous_data_get, const Efl_Gesture_Touch_Point_Data *, NULL);

const Efl_Gesture_Touch_Point_Data *_efl_canvas_gesture_touch_data_get(const Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd, unsigned int id);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV_CONST(efl_gesture_touch_data_get, const Efl_Gesture_Touch_Point_Data *, NULL, EFL_FUNC_CALL(id), unsigned int id);

Efl_Object *_efl_canvas_gesture_touch_efl_object_constructor(Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd);


void _efl_canvas_gesture_touch_efl_object_destructor(Eo *obj, Efl_Canvas_Gesture_Touch_Data *pd);


static Eina_Bool
_efl_canvas_gesture_touch_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_CANVAS_GESTURE_TOUCH_EXTRA_OPS
#define EFL_CANVAS_GESTURE_TOUCH_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_point_record, _efl_canvas_gesture_touch_point_record),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_delta, _efl_canvas_gesture_touch_delta),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_distance, _efl_canvas_gesture_touch_distance),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_start_point_get, _efl_canvas_gesture_touch_start_point_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_current_point_get, _efl_canvas_gesture_touch_current_point_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_current_timestamp_get, _efl_canvas_gesture_touch_current_timestamp_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_points_count_get, _efl_canvas_gesture_touch_touch_points_count_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_state_get, _efl_canvas_gesture_touch_state_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_current_data_get, _efl_canvas_gesture_touch_current_data_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_previous_data_get, _efl_canvas_gesture_touch_previous_data_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_data_get, _efl_canvas_gesture_touch_data_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_canvas_gesture_touch_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_canvas_gesture_touch_efl_object_destructor),
      EFL_CANVAS_GESTURE_TOUCH_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"current_timestamp", NULL, __eolian_efl_canvas_gesture_touch_current_timestamp_get_reflect},
      {"touch_points_count", NULL, __eolian_efl_canvas_gesture_touch_touch_points_count_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_canvas_gesture_touch_class_desc = {
   EO_VERSION,
   "Efl.Canvas.Gesture_Touch",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Canvas_Gesture_Touch_Data),
   _efl_canvas_gesture_touch_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_canvas_gesture_touch_class_get, &_efl_canvas_gesture_touch_class_desc, EFL_OBJECT_CLASS, NULL);
